/** ###################################################################
**     Filename  : LCD.C
**     Project   : rfid_mid8
**     Processor : MC9S08QG4CDN
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 13.7.2008, 13:10
**     Contents  :
**         User source code
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE LCD */
/* Including used modules for compiling procedure */
#include "Cpu.h"
#include "Events.h"
#include "Bit_cs.h"
#include "Bit_clock.h"
#include "Bit_data.h"
#include "Bit_addr_data.h"
//#include "ExInter.h"
//#include "LCD.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

#include "SPI.h"

void InitLCD(void) 
 {
 SendAddr(0x02); //ADDR
       
 SendData(0x13);
 SendData(0x03);
 SendData(0x13);
 SendData(0x03);
 SendData(0x13);
 SendData(0x03);
 SendData(0x12);
 SendData(0x02);
      
 SendData(0x12);
 SendData(0x02);
 SendData(0x18);
 SendData(0x08);
 SendData(0x10);
 SendData(0x00);
 SendData(0x18);
 SendData(0x08);
 SendData(0x10);
 SendData(0x00);
 SendData(0x11);
 SendData(0x01);
 SendData(0x10);
 SendData(0x00);
 SendData(0x16);
 SendData(0x06);
 SendData(0x10);
 SendData(0x00);
 SendData(0x1C);
 SendData(0x0C);
                            
 SendAddr(0x00);
 return;
 }
 
 
 
 void writeLCDradek1(void) 
 {
 SendAddr(0x02); //ADDR
 
 SendData(0x18);
 SendData(0x00);
 SendData(0x10);
 SendData(0x00);
 
 SendAddr(0x00);
 }
 
 void writeLCDradek2(void) 
 {
 SendAddr(0x02); //ADDR
 
 SendData(0x1C);
 SendData(0x00);
 SendData(0x10);
 SendData(0x00);
 
 SendAddr(0x00);
 }
 
 void writeLCD1(byte znak) 
 {
 
 //SendAddr(0x02); //ADDR
  
 SendData((0x30)|(znak>>4));
 SendData((0x20)|(znak>>4));
 SendData((0x30)|(znak & 0x0F));
 SendData((0x20)|(znak & 0x0F));
                                   
 //SendAddr(0x00);
 }
 
  
 void WriteLCDnapis1(void) 
 {
 writeLCDradek1();
 SendAddr(0x02); //ADDR
 writeLCD1('R');
 writeLCD1('F');
 writeLCD1('I');
 writeLCD1('D');
 writeLCD1(' ');
 writeLCD1('S');
 writeLCD1('y');
 writeLCD1('s');
 writeLCD1('t');
 writeLCD1('e');
 writeLCD1('m');
 writeLCD1(' ');
 writeLCD1('M');
 writeLCD1('I');
 writeLCD1('D');
 writeLCD1('8');
 SendAddr(0x00);
 }
 
 void WriteLCDnapis2(void) 
 {
 writeLCDradek2();
 SendAddr(0x02); //ADDR
 writeLCD1(' ');
 writeLCD1('P');
 writeLCD1('r');
 writeLCD1('i');
 writeLCD1('l');
 writeLCD1('o');
 writeLCD1('z');
 writeLCD1('t');
 writeLCD1('e');
 writeLCD1(' ');
 writeLCD1('k');
 writeLCD1('a');
 writeLCD1('r');
 writeLCD1('t');
 writeLCD1('u');
 writeLCD1(' ');
 SendAddr(0x00);
 }
 
 void WriteLCDnapis3(void) 
 {
 writeLCDradek2();
 SendAddr(0x02); //ADDR
 writeLCD1(' ');
 writeLCD1('N');
 writeLCD1('e');
 writeLCD1('p');
 writeLCD1('l');
 writeLCD1('a');
 writeLCD1('t');
 writeLCD1('n');
 writeLCD1('a');
 writeLCD1(' ');
 writeLCD1('k');
 writeLCD1('a');
 writeLCD1('r');
 writeLCD1('t');
 writeLCD1('a');
 writeLCD1(' ');
 SendAddr(0x00);
 }
 
 void WriteLCDnapis4(void) 
 {
 writeLCDradek2();
 SendAddr(0x02); //ADDR
 writeLCD1(' ');
 writeLCD1('V');
 writeLCD1('s');
 writeLCD1('t');
 writeLCD1('u');
 writeLCD1('p');
 writeLCD1(' ');
 writeLCD1('p');
 writeLCD1('o');
 writeLCD1('v');
 writeLCD1('o');
 writeLCD1('l');
 writeLCD1('e');
 writeLCD1('n');
 writeLCD1(' ');
 writeLCD1(' ');
 SendAddr(0x00);
 }
 
 void WriteLCDnapis5(void) 
 {
 writeLCDradek2();
 SendAddr(0x02); //ADDR
 writeLCD1(' ');
 writeLCD1('M');
 writeLCD1('a');
 writeLCD1('s');
 writeLCD1('t');
 writeLCD1('e');
 writeLCD1('r');
 writeLCD1(' ');
 writeLCD1('U');
 writeLCD1('A');
 writeLCD1('R');
 writeLCD1('T');
 writeLCD1(' ');
 writeLCD1('O');
 writeLCD1('n');
 writeLCD1(' ');
 SendAddr(0x00);
 }



/* END LCD */
