/** ###################################################################
**     Filename  : SPI.C
**     Project   : rfid_mid8
**     Processor : MC9S08QG4CDN
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 13.7.2008, 13:11
**     Contents  :
**         User source code
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/

/* MODULE SPI */

/* Including used modules for compiling procedure */
#include "Cpu.h"
//#include "Events.h"
#include "Bit_cs.h"
#include "Bit_clock.h"
#include "Bit_data.h"
#include "Bit_addr_data.h"
#include "Bit_Int.h"
//#include "LCD.h"
/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

//byte data, mask, i;
 
 void SendTX(byte bb)
 {
 
  data = bb;
  Bit_clock_ClrVal();
  Bit_cs_SetVal(); 
  Cpu_Delay100US(1); 
  mask=128;                
                                                                  
   // 8 output bits                                              
   for (ii=0;ii<8;ii++) { // lsb 1st  8 bits                         
      if (mask & data) {                                          
         Bit_data_SetVal(); // output low for logic 1                        
      } else {                                                    
         Bit_data_ClrVal();// output high for logic 0                        
                                                        
      }           
      Bit_clock_NegVal();                                                 
      mask >>=1;                                                  
      //Cpu_Delay100US(1); 
      Bit_clock_NegVal();
      Cpu_Delay100US(1);     
   }

   Bit_cs_ClrVal(); 
 return;
 };
 
  
 byte ReadRX(void) 
 {
  Bit_cs_ClrVal();
  Bit_clock_ClrVal();
  
  Bit_addr_data_SetVal(); //LOAD
  Bit_cs_SetVal();
  Cpu_Delay100US(1);
  Bit_cs_ClrVal();
  Bit_addr_data_ClrVal();
  
  Bit_cs_SetVal();
  
  mask=0;
  
  for (ii=0;ii<8;ii++) {
  if (Bit_Int_GetVal()) {
       mask=((mask << 1) | 0x01); // for logic 1                        
  } else {
      mask=(mask << 1);//  for logic 0
  }
   Bit_clock_SetVal();
  Cpu_Delay100US(1); 
  Bit_clock_ClrVal();
  Cpu_Delay100US(1);
  }
  Bit_cs_ClrVal();
  
  return mask;
 }
 
 
 
  void SendData(byte bb) 
 {
  Bit_addr_data_ClrVal();
  SendTX(bb);
 }
 
 void SendAddr(byte bb) 
 {
  Bit_addr_data_SetVal();
  SendTX(bb);
  Bit_addr_data_ClrVal();
 }



/* END SPI */
