/** ###################################################################
**     Filename  : rfid_mid8.C
**     Project   : rfid_mid8
**     Processor : MC9S08QG4CDN
**     Version   : Driver 01.10
**     Compiler  : CodeWarrior HCS08 C Compiler
**     Date/Time : 13.7.2008, 12:39
**     Abstract  :
**         Main module.
**         Here is to be placed user's code.
**     Settings  :
**     Contents  :
**         No public methods
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol. s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################*/
/* MODULE rfid_mid8 */


/* Including used modules for compiling procedure */
#include "Cpu.h"
#include "Bit_cs.h"
#include "Bit_clock.h"
#include "Bit_data.h"
#include "Bit_addr_data.h"
#include "Bit_Int.h"
#include "LCD.h"
#include "SPI.h" 
#include "UART.h"

/* Include shared modules, which are used for whole project */
#include "PE_Types.h"
#include "PE_Error.h"
#include "PE_Const.h"
#include "IO_Map.h"

void Otevri() 
{
WriteLCDnapis4();

//zapise na LED
  SendData(0xFF);
  SendAddr(0x08);  
  SendAddr(0x00);
  
  while(!Bit_Int_GetVal());
  
  SendData(0x00);
  SendAddr(0x08);  
  SendAddr(0x00);
  WriteLCDnapis2();
}

void Zavreno() 
{
WriteLCDnapis3();

//zapise na LED
  SendData(0xC0);
  SendAddr(0x08);  
  SendAddr(0x00);
  
  while(!Bit_Int_GetVal());
  
  SendData(0x00);
  SendAddr(0x08);  
  SendAddr(0x00);
  WriteLCDnapis2();
}

void main(void)
{
  /* Write your local variable definition here */
 /* uint8_t pom;
  uint8_t i;
  uint8_t j;
  uint8_t indexp;
  uint8_t indexk;
  uint8_t paket[10];  
  uint8_t karta[10];   
  
  //uint8_t * ppaket;
  
  //byte data, mask, i;
   
  unsigned char platnost[5][6]; //karta kod   posledni byte -vstup
  
  */

  /*** Processor Expert internal initialization. DON'T REMOVE THIS CODE!!! ***/
  PE_low_level_init();
  /*** End of Processor Expert internal initialization.                    ***/

  /* Write your code here */
  /* For example: for(;;) { } */
   
  //smaze FD reg.RX
  SendAddr(0x01);   
  SendAddr(0x00);
  
  //zapise na LED
  SendData(0x00);
  SendAddr(0x08);  
  SendAddr(0x00);
  
  InitLCD();  
  WriteLCDnapis1();
  WriteLCDnapis2();
  
  indexp=0;
  indexk=0;
  
  for(i=0;i<5;i++)
    for(j=0;j<6;j++) platnost[i][j]=0;
    
  for(;;){
    
  SendAddr(0x90);   //cte Flag  
  pom=ReadRX();
  
  if(pom==0x01)    //flag je nastaven RFID
  {
    
   SendAddr(0xB0);   //cte UART_RFID
   pom=ReadRX();
   
   karta[indexk]=pom;
   indexk=indexk+1;
   
   if(indexk>=10) {
   indexk=0;
   
   SendAddr(0x01); //smaze FD reg.RX
   SendAddr(0x00);
   
   //rozhodovani o platnosti
   pom=0;
   for(i=0;i<5;i++) 
   {
   if((karta[6]==platnost[i][0])&(karta[7]==platnost[i][1])&(karta[8]==platnost[i][2])&
   (karta[9]==platnost[i][3])&(platnost[i][4]==0x41)) { Otevri(); pom=1; i=7;}
   }
   
   if(pom==0) Zavreno();
   }
  }
  
  if(pom==0x02)    //flag je nastaven UART
  {
  
   SendAddr(0xA0);   //cte UART_RX
   pom=ReadRX();
   
   if(pom=='@') indexp=0;
   
   paket[indexp]=pom;
   
  //ppaket=&paket[0];
  //  *(ppaket+indexp)=pom;
   indexp=indexp+1;
   
   if(indexp>=6) {
   indexp=0;
  
   SendAddr(0x01); //smaze FD reg.RX
   SendAddr(0x00);
  
   //povoleni karty @ A5CF A (zakaz Z)
    pom=0;
  
   for(i=0;i<5;i++) 
   {
   if((paket[1]==platnost[i][0])&(paket[2]==platnost[i][1])&(paket[3]==platnost[i][2])&(paket[4]==platnost[i][3])) 
   {
    platnost[i][4]=paket[5];
    pom=1;
   }
   }
   
   if(pom==0) 
   {
      for(i=0;i<5;i++) 
      {
      if((platnost[i][0]==0)&(platnost[i][1]==0)&(platnost[i][2]==0)&(platnost[i][3]==0)) 
        {
        platnost[i][0]=paket[1];
        platnost[i][1]=paket[2];
        platnost[i][2]=paket[3];
        platnost[i][3]=paket[4];
        platnost[i][4]=paket[5];
        i=7;
        }
      }
   }
   
   
   } //index6
  }//pom==2
   

  }
  /*** Don't write any code pass this line, or it will be deleted during code generation. ***/
  /*** Processor Expert end of main routine. DON'T MODIFY THIS CODE!!! ***/
  for(;;){}
  /*** Processor Expert end of main routine. DON'T WRITE CODE BELOW!!! ***/
 /*** End of main routine. DO NOT MODIFY THIS TEXT!!! ***/
}
/* END rfid_mid8 */
/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 2.98 [03.80]
**     for the Freescale HCS08 series of microcontrollers.
**
** ###################################################################
*/
